#!/bin/bash

PASSWD=/etc/passwd
JAILHOME=/home/scponly
SCPONLYSH=/usr/local/sbin/scponlyc
TMPPASSWD=/etc/passwd.scp.tmp
DATE=`date +'%d%m%y-%k%M%S'`

if [ -z "$1" ]; then
   echo "Verwendung: addscpaccess.sh <username>"
   exit 1 
fi

# Sanity Check: Gibt es den user, gibt es sein home?
# Aus der passwd
# Eindeutige abfrage
LINE=`grep --regexp=^$1: $PASSWD`

if [ -z "$LINE" ]; then 
  echo "Der Benutzer $1 existiert im System nicht."
  exit 1;
fi
echo Win SCP zugang fr Benutzer $1 wird eingerichtet:

HOME=`echo $LINE | awk -F : '{print $6}' -`
SHELL=`echo $LINE | awk -F : '{print $7}' -`

# Shell in der Passwortzeile ersetzen
NEWLINE=`echo $LINE | sed "s#$SHELL#$SCPONLYSH#" -`

echo "  Derzeitige Shell: $SHELL."
echo "  Neue Shell:       $SCPONLYSH."

if [ -d $HOME ]; then 
	echo "  Homeverzeichnis:  $HOME existiert."
else 
        echo "Homeverzeichnis existiert nicht."
        exit 1
fi

# Gibt es schon einen Eitrag im Jail?
USEREXISTS=`grep --regexp=^$1: $JAILHOME/etc/passwd`
if [ -n "$USEREXISTS" ]; then
        echo "Es sieht so aus, als wre der Benutzer $1 bereits fr SCP eingerichtet."
        exit 1
fi

# Alle Dateien im Home des Benutzers lschen auer dem UVZ windows
for file in $HOME/*; do
	if [ $file != $HOME/windows ]; then
		rm -rf $file
	fi
done
# Alle versteckten Dateien im Home lschen
rm -rf  $HOME/.* > /dev/null 2>&1
# Eigentmer root.root 
chown root.root $HOME
chmod 755 $HOME

#Verzeichnisstruktur vom Jailuser bernehmen
cd $JAILHOME && find * -type d -exec mkdir -p $HOME/{} \; > /dev/null 2>&1

# Hardlinks auf alle Dateien im Jail
cd $JAILHOME && find * -type f -exec ln $JAILHOME/{} $HOME/{} \; > /dev/null 2>&1

# Sichern der Passwortdate und erseten des Shelleintrags
rm -f $TMPPASSWD > /dev/null 2>&1
sed "s#$LINE#$NEWLINE#" $PASSWD > $TMPPASSWD
chown root.root $TMPPASSWD
chmod 644 $TMPPASSWD
cp -a $PASSWD $PASSWD.scp.$DATE
mv $TMPPASSWD $PASSWD
chown root.root $PASSWD
chmod 644 $PASSWD

# Eintrag des users in der jail paasswd
echo $NEWLINE >> $JAILHOME/etc/passwd


